<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/1999/REC-html401-19991224/strict.dtd">
<html>
<Head>

<!-- 
	University of Illinois/NCSA Open Source License for kmiexprun.php.

Copyright (c) 2008 Jim Champ/Surrey County Council 
All rights reserved.
Developed by: 		Jim Champ
                    www.devboats.co.uk/idmphp/
Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal with the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimers. 

Redistributions in binary form must reproduce the above
copyright notice, this list of conditions and the following disclaimers
in the documentation and/or other materials provided with the
distribution. 

Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
or promote products derived from this Software without specific prior
written permission. 
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE. 
 
pkiexp.php is intended to lookup and present the expiry dates of the ssl certificates
in an edirectory implementation, and highlight those which will expire soon.

 -->

<TITLE>KMI Expiry Date List</TITLE>
</head>
<body>
<H1>SSL Certificate List with Expiry Dates</H1>

<?php
// newer systems support the _post system for posted variable
// older ones http_post_vars so we test for both...
// Thanks to Mike James for spotting this problem - I don't have a system which
// doesn't support http_post_vars so hadn't seen it. Thanks also to
// Sebastian Lukasz who tested out this fix.

if (@$_POST['ldap_id'] > "" ) {
	$ldap_pw=$_POST['ldap_pw'];
	$ldap_id=$_POST['ldap_id'];
	$ldap_server=$_POST['ldap_server'];
	$ldap_root= $_POST['ldap_root'];
	$cert_name= $_POST['cert_name'];
	$months_ahead= $_POST['months_ahead'];
} else {
	if (@$HTTP_POST_VARS['ldap_id'] > "" ) {
		$ldap_pw=$HTTP_POST_VARS['ldap_pw'];
		$ldap_id=$HTTP_POST_VARS['ldap_id'];
		$ldap_server=$HTTP_POST_VARS['ldap_server'];
		$ldap_root= $HTTP_POST_VARS['ldap_root'];
		$cert_name= $HTTP_POST_VARS['cert_name'];
		$months_ahead= $HTTP_POST_VARS['months_ahead'];

	} else {
		echo " <h2>kmiexprun.php must be run from kmiexp.php</h2>\n";
		echo "<p>Please select <a href=\"kmiexp.php\"> this link to run the KMI expiry report.</p>";
		exit;
	}
}

// This attribute seems to be pretty good to identify SSL certificates...
// $certname restricts us to a particular one...
$ldap_sr="nDSPKINotAfter=*" ;

//$months_ahead = 0;
// this tells the app to look ahead one month (the date string in the cert is in Ymd (=yyyymmdd) format)
// you can vary it, but you'll need extra code if you wish to handle part months.

$exp_check_date = date("Ymd") ;
// echo "<p>Today Date  is : " . $exp_check_date . ".</p>\n";

$mnth = date("m");
// echo "<p>Month Date  is : " . $mnth . ".</p>\n";

// // exp_check_date is incremented by the amount that we want to test...
$look_ahead = 100 * $months_ahead ;
// check this maths... I haven't tested two months, 3 months etc...
$end_year = 8800;

if ($mnth > 12 - $months_ahead) {
	// then we need to make allowances for end of year maths...
	// seeing as this isn't a date vale but a text one...
	$exp_check_date = $exp_check_date + $end_year + $look_ahead;
	//echo "<p>End Year</p>";
} else {
	// echo "<p>Normal Month</p>";
	$exp_check_date = $exp_check_date + $look_ahead;
}

// echo "<p>Check Date  is : " . $exp_check_date . ".</p>\n";

// usercomms message...
echo "<p></p><p>Expired SSL Certificates can cause operational problems, in particular with remote control and \n";
echo " web services such as iPrint . Certicates in the rows shown in red have expired or are about to expire and \n";
echo " should be renewed, say using pkidiag. However certificate names starting in &quot;Old&quot; are backup \n";
echo " copies created by pkidiag, need not be renewed and can be deleted.</p><p>\n";

// So we start by connecting to LDAP]]

echo "<p>Connecting to LDAP server...  ";

$ds=ldap_connect("$ldap_server");  // must be a valid LDAP server!

// echo "\n<br>Connection results: ".$ds."</p>";

if(@ldap_bind($ds, $ldap_id,$ldap_pw)) {
	echo " ...succeeded</p>\n";
	// we have now made an LDAP connection
} else {
	echo " failed.</p>\n<h2>LDAP Authentication Failed</h2>\n";
	echo "<p>User id and/or Password credentials were incorrect</p>\n";
	echo "<p>User id and context entered was " . $ldap_id . "</p>\n";
	echo "<p>Use back to go back to the form and renter the LDAP user id and password. Make sure that you used ";
	echo "correct LDAP syntax (ou=unit,o=org) rather than NDS syntax for the user context.</p>\n";
	exit;
}

echo "<table>\n";
echo "<tr><th>Certficate DN</th><th>Host Server</th><th>Expiry Date</th><th>Activation Date</th></tr>\n";

//   echo "Searching in " . $ldap_root , " for " . $ldap_sr . " ...\n";
// 21 May 09, Added array of ldap attrs to the ldap_search call. This improves performance
// as only the names attributes are returned. Ensure all attributes you wish to read are
// listed in this array. Note that the attribute names are case sensitive.
$sr=@ldap_search($ds, $ldap_root, $ldap_sr ,array(cn, nDSPKINotAfter, nDSPKINotBefore, hostServer,  ));  
$sr=@ldap_search($ds, $ldap_root, $ldap_sr );
//   echo "\nSearch result is " . $sr . "<br /\n>";

$entry = @ldap_first_entry($ds, $sr);
if(@ldap_count_entries($ds, $sr) == 1 ) {
	// echo  "1 directory entry returned.</p>\n";
} else {
	// echo  @ldap_count_entries($ds, $sr) . " directory entries returned.</p>\n";
}

while ($entry) {
	$attrs = @ldap_get_attributes($ds,$entry);
	$udn = @ldap_get_dn($ds,$entry);
	// no need to report on every cert in the server, although you can take this if
	// statement out and do so if you wish...
	if(strlen( stristr($udn,$cert_name)) > 5) {
		// if its not > 5 characters it can't be  valid value!!
		$af = @substr(@$attrs["nDSPKINotAfter"][0],0,8);
		$bf = @$attrs["nDSPKINotBefore"][0];
		
		if($af < $exp_check_date) {
			echo  "<tr style=\"background-color:#FF9999;\"><td>" . $udn . "&nbsp;</td><td>";
		} else {
			echo  "<tr><td>" . $udn . "&nbsp;</td><td>";
		}
	
		// echo  $af . "<br>" . $exp_check_date . "</td><td>";
		echo  @$attrs["hostServer"][0] . "&nbsp;</td><td>";
		$faf = substr($af,6,2) . "/" . substr($af,4,2) . "/" . substr($af,0,4);
		$fbf = substr($bf,6,2) . "/" . substr($bf,4,2) . "/" . substr($bf,0,4);
		echo $faf .  "</td><td>" . $fbf . "</td></tr>\n";
	}
	$entry = ldap_next_entry($ds, $entry);
}

echo "</table></p>\n";
ldap_close($ds);

?>

</body>
</html>
